import josx.platform.rcx.*;

public class FollowTheLine {

//	private Sensor S1;	// Lichtsensor
//	private Sensor S2;	// Lichtsensor
//	private Sensor S3;	// rechter Berhrungssensor
	
	static Motor M_left = Motor.A;	// linker Motor
	static Motor M_right = Motor.C;// rechter Motor
	
	static Sensor S_right = Sensor.S3;
	static Sensor S_middle = Sensor.S2;
	
	static int floor;	// Untergrundhelligkeitswert
	static int line;	// Linienhelligkeitswert
	static int border;	// Grenzwert zw. Linie und Untergrund
	
	static int f_speed; // Geschwindigkeit nach Vorn
	static int l_speed;	// Geschwindigkeit der Linksdrehung
	static int r_speed;	// Geschwindigkeit der Rechtsdrehung
	
	static int maxSpeed=2; 

	static byte codedDirection; 
//	static byte[] buffer = new byte[2];
	static byte[] buffer = {(byte)0xf7, (byte)0x00};
	
	static boolean isCrashed;	// Wenn der Berhrungssensor ausgelst wird
	static int isOnLine;	//Ist der Robo auf der Linie
	
	static int turntime;

	
	// Lichtsensor einstellen
	static void justieren() {
		
		// Untergrund einlesen
		
//		TextLCD.print("floor"); sleep(1000);
		TextLCD.print("press"); sleep(1000);
		TextLCD.print("VIEW");
		Sound.beep();
		
		while (!Button.VIEW.isPressed()) {
			floor=0;
			line=0;
		}
		while (Button.VIEW.isPressed()) {
			floor = Math.max(S_right.readRawValue(),floor);
			line = Math.max(S_middle.readRawValue(),line);
		}
		
		// Linie einlesen
		
//		TextLCD.print("line"); sleep(1000);
//		TextLCD.print("press"); sleep(1000);
//		TextLCD.print("VIEW");
//		Sound.beep();
		
		// Grenze berechnen
		border = (floor + line) / 2;
//		LCD.showNumber(border);
		Sound.beepSequence();
		sleep(1000);
	}
	
	static void go() {
		TextLCD.print("Busy");
//		int time;
//		int i,c;
//		boolean turnleft = true;
		
		// so lange fahren, bis [Run] gedrckt wurde
		while (!Button.RUN.isPressed()&&!isCrashed) {
			drive_forward();
			sleep(2);
//			time = 5;
			isOnLine=onTheLine();
			while(isOnLine!=0){
				steer(isOnLine<0);		//true=nach links drehen
				isOnLine=onTheLine();
			}
		}			// Ausfhrung bis [RUN]-Druck
		stop();		// Robo-Stopp bei [RUN]-Druck
		if (!isCrashed)TextLCD.print("Stop");
		sleep(5000);
	}
			

	// Sensor S1 gibt Einlesewert zurck
	static int getValue(Sensor S_source) {
		return S_source.readRawValue();
	}
	
	// Ist Robo auf der Linie?
	static int onTheLine() {
		if (getValue(S_right)>border) return 1;		// zu weit Links
		if (getValue(S_middle)<border) return -1; 	// zu weit Rechts
		return 0;
	}
	
	static int directionCoder(int speed){
		codedDirection=0;
		if (M_left.isForward()) codedDirection+=16;
		if (M_right.isForward()) codedDirection+=8;
		codedDirection+=speed;
		return codedDirection;
	}
	
	// Vorwrts fahren
	static void drive_forward() {
		if (f_speed<maxSpeed){
			l_speed=0;
			r_speed=0;
			f_speed++;
			M_left.setPower(f_speed);
			M_right.setPower(f_speed);
			M_left.forward();
			M_right.forward();
			directionCoder(f_speed);
			send(codedDirection);
		}
	}
	
	// Rckwrts fahren
//	static void drive_backward() {
//		M_left.backward();
//		M_right.backward();
//	}
	
	static void steer(boolean leftDirection)	{
		if (leftDirection) steer_left();
		else steer_right();
	}
	// Nach links lenken
	static void steer_left() {
		if (l_speed<maxSpeed){
			f_speed=0;
			r_speed=0;
			l_speed++;
			M_left.setPower(l_speed);
			M_right.setPower(l_speed);
			M_left.backward();
			M_right.forward();
			directionCoder(l_speed);
			send(codedDirection);
		}
	}
	
	// Nach rechts lenken
	static void steer_right() {
		if (r_speed<maxSpeed){
			f_speed=0;
			l_speed=0;
			r_speed++;
			M_left.setPower(r_speed);
			M_right.setPower(r_speed);
			M_left.forward();
			M_right.backward();
			directionCoder(r_speed);
			send(codedDirection);
		}
	}
	
	// Robo anhalten
	static void stop() {
		M_left.stop();
		M_right.stop();
		directionCoder(0);
		send(codedDirection);
	}
	
	static void send(byte message) {
		buffer[1]=message;
		Serial.sendPacket(buffer,0,2);
		LCD.showNumber(message);
		Sound.beep();
		try{
		Serial.waitTillSent();
		}
		catch(Exception e){}
	}
	// Um 90 nach rechts drehen und anhalten
/*	static void gorightangle() {
		M_left.forward();
		M_right.backward();
		sleep(turntime);
		stop();
	}
	
	// Um 90 nach links drehen und anhalten
	static void goleftangle() {
		M_right.forward();
		M_left.backward();
		sleep(turntime);
		stop();
	}*/
	
	// Pause
	static void sleep(int milis) {
		try {
			Thread.sleep(milis);

			}
			catch(Exception e){}
			}
	
	public static void main(String[] args) {
		
		// Sensoren aktivieren
		Sensor.S1.activate();
		Sensor.S2.activate();
		Sensor.S3.activate();
		Serial.setRangeLong();
		S_right.setTypeAndMode(SensorConstants.SENSOR_TYPE_LIGHT,
				SensorConstants.SENSOR_MODE_PCT);
		S_middle.setTypeAndMode(SensorConstants.SENSOR_TYPE_LIGHT,
				SensorConstants.SENSOR_MODE_PCT);
		Sensor.S1.setTypeAndMode(SensorConstants.SENSOR_TYPE_TOUCH,
		SensorConstants.SENSOR_MODE_BOOL);
				
//		new FollowTheLine(Sensor.S1, Sensor.S2, Sensor.S3, Motor.A, Motor.C);
		
		isCrashed = false;
		
		Sensor.S1.addSensorListener (new SensorListener() {
		     public void stateChanged (Sensor src, int oldValue, int newValue) {
		       // Will be called whenever sensor value changes
		    	 isCrashed = (newValue == 1);
		    	 if (isCrashed) TextLCD.print("Crash") ; 
		     }
		   });
		
/*		S1 = sens1;			// linker Berhrungssensor
		S2 = sens2;			// Lichtsensor
		S3 = sens3;			// rechter Berhrungssensor*/
		
		border=0;
//		turntime=1150;
		
		justieren(); 	// Linchtsensor einstellen
		go(); 			// Na dann mal los...
	}
	
}